global class ScheduleMatch
{ 
/*
Datetime dtNow = System.now();
    Datetime dtStart = dtNow.addMinutes(-30);
    Datetime dtEnd = dtNow.addMinutes(30);
String strStart = dtStart.format('yyyy-MM-dd\'T\'hh:mm:ss\'Z\'');
String strEnd = dtEnd.format('yyyy-MM-dd\'T\'hh:mm:ss\'Z\'');
String strquery =  'Select Name,Id,Status__c,MetroAreas__c,Other_Languages__c, Languages_spoken_other_than_English__c, NPO_User__c,Template__c,Volunteering_Corporation__c,Next_Match_On__c  from Project__c where Next_Match_On__c >' +strStart  + ' and Next_Match_On__c < ' + strEnd ;
System.debug(strquery);
    Project__c[] arrProject = Database.query(strquery);

global void execute(SchedulableContext sc) {
    Datetime dtNow = System.now();
    Datetime dtStart = dtNow.addMinutes(-30);
    Datetime dtEnd = dtNow.addMinutes(30);
    
    String strStart = dtStart.format('yyyy-MM-dd\'T\'hh:mm:ss\'Z\'');
    String strEnd = dtEnd.format('yyyy-MM-dd\'T\'hh:mm:ss\'Z\'');
    
    String strQuery = 'Select Name,Id,Status__c,MetroAreas__c,Other_Languages__c, Languages_spoken_other_than_English__c, NPO_User__c,Template__c,Volunteering_Corporation__c,Next_Match_On__c  from Project__c where Next_Match_On__c > '+ strStart +' and Next_Match_On__c < '+ strEnd;
    MatchingFunctionality Matchfunc = new MatchingFunctionality(strQuery);
    database.executebatch(Matchfunc,1);
}
Datetime dtNow = System.now();
    Datetime dtStart = dtNow.addMinutes(-60);
    Datetime dtEnd = dtStart .addMinutes(120);
    
    String strStart = dtStart.format('yyyy-MM-dd\'T\'hh:mm:ss\'z\'');
    String strEnd = dtEnd.format('yyyy-MM-dd\'T\'hh:mm:ss\'z\'');
    
    String strQuery = 'Select Name,Id,Status__c,MetroAreas__c,Other_Languages__c, Languages_spoken_other_than_English__c, NPO_User__c,Template__c,Volunteering_Corporation__c,Next_Match_On__c  from Project__c where Next_Match_On__c > '+ strStart ;
Project__c[] projetcs =Database.Query(strQuery);
    MatchingFunctionality Matchfunc = new MatchingFunctionality(strQuery);
    database.executebatch(Matchfunc,1);
*/
public Project__c Project {get;set;}    
    List<Template_Skill__c> lstTemplateSkills;
    List<VolSkillScore__c> lstVolSkillScore;
    
    public void GetTemplatesWithTemplateSkill(Project__c Project)
    {
        
        if(Project != null && Project.Status__c == 'Open Projects-Awaiting Volunteers')
        {
            lstTemplateSkills = new List<Template_Skill__c>();
            //Retrieve all the template skills for the tempalte
            lstTemplateSkills = [Select Id, Template__r.NumberofRequiredSkills__c,Template__c, Skill__c, Nice_to_Have__c, Required__c,Skill__r.Name,Skill__r.Id , Guru_Question__c from Template_Skill__c where Template__c = :Project.Template__c];
        }
        else
            return;
        if(lstTemplateSkills != null && lstTemplateSkills.size() > 0)
        {
            List<Match.MatchedVolunteer> lstMatchedVolunteerObjects;
            lstVolSkillScore = new  List<VolSkillScore__c>();
            List<VolSkillScore__c> lstTempVolSkillScore  = new List<VolSkillScore__c>();
            Set<Id> setSkills = new Set<Id>();
            Map<Id,Map<Id,VolSkillScore__c>> mapVolunteerWithSkills = new Map<Id,Map<Id,VolSkillScore__c>>();
            
            for(Template_Skill__c tempSkills : lstTemplateSkills)
                setSkills.add(tempSkills.Skill__c);
            
            List<Match__c> lstAlreadyMatchedVolunteers = [Select m.Volunteer__c, m.Project__c From Match__c m where m.Project__c = :Project.id];
            set<Id> setAlreadyMatchedVolunteers = new set<Id>();
            for(Match__c match : lstAlreadyMatchedVolunteers)
                setAlreadyMatchedVolunteers.add(match.Volunteer__c);
                
            if(setSkills != null && setSkills.size() > 0 )
            {
                System.debug('SetSkills ' + setSkills.size() + ' ' + setSkills);
                lstVolSkillScore = [Select Volunteer__r.IsCorporate__c,Volunteer__r.Unresponsive__c,Volunteer__r.Languages_other_than_English__c,Volunteer__r.Other_Languages__c, Volunteer__r.MetroAreas__c, Volunteer__r.of_Pending_Responses__c, Volunteer__r.Donotmatchme__c, Volunteer__r.Name,Volunteer__c,Volunteer__r.AccountId,Volunteer__r.Types_of_nonprofits__c, Skill__c, Skill_Score__c, Name, Id From VolSkillScore__c v where Skill__c in : setSkills and Volunteer__r.of_Pending_Responses__c < : GlobalSettings.RequiredMatchCutoff and Volunteer__r.Unresponsive__c = : false and Volunteer__r.Donotmatchme__c = :false];
                if(lstVolSkillScore != null && lstVolSkillScore.size() > 0)
                {
                    System.debug('lstVolSkillScore ' + lstVolSkillScore.size() + ' ' + lstVolSkillScore);
                    for(VolSkillScore__c volSkills : lstVolSkillScore)
                    {
                        if(!setAlreadyMatchedVolunteers.contains(volSkills.Volunteer__c))
                        {
                            if(!mapVolunteerWithSkills.containsKey(volSkills.Volunteer__c))
                            {   
                                Map<Id,VolSkillScore__c> mapVolskills = new Map<Id,VolSkillScore__c>();
                                mapVolskills.put(volSkills.Skill__c,volSkills);
                                mapVolunteerWithSkills.put(volSkills.Volunteer__c,mapVolskills);
                            }                                   
                            else if(mapVolunteerWithSkills.containsKey(volSkills.Volunteer__c))
                                mapVolunteerWithSkills.get(volSkills.Volunteer__c).put(volSkills.Skill__c,volSkills);
                        }
                    }
                    System.debug('mapVolunteerWithSkills::'+mapVolunteerWithSkills);
                    
                    if(mapVolunteerWithSkills != null && mapVolunteerWithSkills.size() > 0)
                    {
                        lstMatchedVolunteerObjects = new List<Match.MatchedVolunteer>();
                        for(Id id : mapVolunteerWithSkills.keySet())
                        {
                            Match.MatchedVolunteer item = new Match.MatchedVolunteer(mapVolunteerWithSkills.get(id),lstTemplateSkills,Project);
                            lstMatchedVolunteerObjects.add(item);
                        }
                    }
                }
            }
            else
                System.debug('No skills found for template skills');
            if(lstMatchedVolunteerObjects != null && lstMatchedVolunteerObjects.size() > 0)
            {
                System.debug('lstMatchedVolunteer::'+lstMatchedVolunteerObjects);
                ArrayUtils.qsort(lstMatchedVolunteerObjects,new MatchedVolunteerComparator(),false);
                System.debug('lstMatchedSorted'+lstMatchedVolunteerObjects);
                Integer iIndex = 0;
                List<Match__c> createMatches = new List<Match__c>();
                while(iIndex < 4 && lstMatchedVolunteerObjects.size() > iIndex)
                {
                    if(lstMatchedVolunteerObjects.get(iIndex).Ranking > 0)
                    {
                        Match__c matchRec = new Match__c();
                        matchRec.NPO_User__c = Project.NPO_User__c;
                        matchRec.Project__c = Project.Id;
                        matchRec.Volunteer__c = lstMatchedVolunteerObjects.get(iIndex).Volunteer.Id;
                        matchRec.Volunteer_Interest__c = 'No Response';
                        matchRec.Nonprofit_Interest__c = 'No Response';
                        createMatches.add(matchRec);
                    }
                    iIndex++;
                }
                
                if(createMatches != null && createMatches.size() > 0)
                {
                    Database.Saveresult[] SaveResult = Database.insert(createMatches);
                    System.debug('SaveResult ' + SaveResult);
                }
                
                Project.Next_Match_On__c = addBussinessDays(System.now(), GlobalSettings.DefaultMatchingSettings.Match_Interval__c.intValue());
                Database.Saveresult[] SaveResultPro = Database.update(new List<Project__c>{ Project});
                System.debug('Updating project ' + SaveResultPro);
            }
        }
        else
            System.debug('No Template Skills found');
    }
    
    public static Boolean compareStrings(String strSource,String strTarget) {
        if(strSource == null || strSource == '' || strTarget == null || strTarget == '')
            return false;
        String[] sarr = strSource.split(';');
        String[] tarr = strTarget.split(';');
        for (Integer iIndex=0; iIndex<sarr.size() ; iIndex++) {
                for (Integer iCount=0; iIndex<tarr.size(); iIndex++) {
                        if (tarr[iIndex] == sarr[iCount]) {
                               return true;
                        }
                }
        }
        return false;
    }
    
    public Datetime addBussinessDays(Datetime startDate, Integer iDays)
    {
        Datetime endDate = startDate.addDays(iDays);
        Integer iOffDays = daysOff(startDate,endDate);
        return endDate.addDays(iOffDays);
        
    }
    
    public Integer daysOff(Datetime sdate, Datetime edate)
    {
         Integer iCount = 0;
         while (sdate < edate) {
           if (sdate.format('E') == 'Sat' | sdate.format('E') == 'Sun'){
             iCount = iCount + 1;
           }
         sdate = sdate.addDays(1);
         }
         return iCount;
    }
}